View Issue Details

IDProjectCategoryView StatusLast Update
0017397mantisbttimelinepublic2015-01-27 19:21
ReportervboctorAssigned Tovboctor 
PrioritynormalSeverityfeatureReproducibilityN/A
Status closedResolutionfixed 
Product Version1.2.17 
Target Version1.3.0-beta.1Fixed in Version1.3.0-beta.1 
Summary0017397: Add timeline to My View page
Description

Add the last week worth of activities to the My View page with the ability to navigate to previous weeks. I've an implementation for which the screenshot is attached.

I already implemented the following events:

  • issue created.
  • note created
  • monitor
  • unmonitor
  • tag added

A lot more can be added, but the goal is to get the feature core done first.

Tagsmantishub

Relationships

related to 0017891 closedvboctor Timeline UI issues 
related to 0017913 closeddregad Hyperlinks in Timeline are not working 
related to 0017918 closedsyncguru "More Events" Hyperlink in Timeline is not working 
related to 0017492 closeddregad Broken styling for Timeline box 
has duplicate 0013779 closedatrol Summary of activity in Mantis today. 
related to 0017966 closedvboctor My View Page takes about 5s to load 

Activities

vboctor

vboctor

2014-06-01 00:58

manager  

timeline.png (183,570 bytes)
timeline.png (183,570 bytes)
vboctor

vboctor

2014-06-01 01:18

manager  

timeline2.png (150,068 bytes)
timeline2.png (150,068 bytes)
vboctor

vboctor

2014-06-01 01:19

manager   ~0040679

I've added a second screenshot with some improvement in look 'n' feel.

vboctor

vboctor

2014-06-01 02:20

manager   ~0040681

Added the following events:

  • issue assigned to self.
  • issue assigned
  • issue resolved
  • issue closed
  • issue reopened
grangeway

grangeway

2014-06-01 04:26

reporter   ~0040682

Can we get 1.3 done, then focus on new features and redesigning the UI with a 'plan'

Personally, in the future I'd see the my view page with as a dashboard that people can customise what appears on boxes etc, and therefore we should keep the boxes in the same style.

Re-designing the UI across the whole of Mantis is something we should focus on after 2.0.

We need to get 1.3 shipped, do a followup 2.0 within a Month of 1.3, and then move the focus onto implementing features ( we are already waiting on 1.3 and 2.0 to get shipped so we can look at email notifications )

vboctor

vboctor

2014-06-01 22:24

manager   ~0040711

Here is the associated pull request:
https://github.com/mantisbt/mantisbt/pull/203

@grangeway, just saw your comment above. This feature is not about redoing the UI, but it is about adding a useful feature that is missing from MantisBT, but available in all competitor bug trackers. I thought I would share this and we can discuss as a team the right time frame for it to get int.

I personally think that given the simplicity of the feature, it can be a nice 1.3 feature. However, if the team wants to hold off on it, I don't mind either. Let's see what others think.

dregad

dregad

2014-06-02 04:07

developer   ~0040712

I rather like the feature and think it would be quite useful, and considering the low impact it has on the codebase, worth adding to 1.3 scope.

I would second @grangeway with regards to allowing users to customize their "My View". While this is a nice-to-have and probably not mandatory for the initial release, need to make sure that we plan ahead to avoid having to rewrite everything in the future.

Maybe we can treat the 'Timeline' box like one of the existing, bug-listing ones ? At the moment, especially if there is not a lot of activity to display, the page looks a bit awkward with all the bug list boxes vertically on the left, and a lot of wasted screen real-estate on the right.

More tactical and detailed comments in the pull request.

dregad

dregad

2014-06-02 04:22

developer   ~0040714

Another idea: allowing users to customize the period (hardcoded 7 days now) via preferences page

vboctor

vboctor

2014-06-02 12:51

manager   ~0040721

@dregard, the feature is designed in a way where it can be included as a div in any page and layout be adjusted via css work. So it is very easy to revisit as part of making My View page more flexible.

If an instance is being used at all, then it is likely that if timeline is empty, the bug boxes will be empty as well. Specially if we provide a configuration option to tweak the number of days to be included in the timeline view.

As for adding the user preferences, I was wondering if we should be able to add preferences without requiring schema change (similar to how we can add configs). I would rather add a preference then, but I'm OK with adding a default config option for number of days.

Once the feature is in, we can iterate on improvements that build on it. I've already applied all your review comments with the exception of the config option. Let me know if you want that, and I will add it.

Related Changesets

MantisBT: master 939ffe34

2014-06-09 21:15:24

mantishub

Details Diff
Fixes 0017397: Timeline Feature

This feature provides users with the ability to know what is going on by co-workers and customers. It provides a timeline view of actions with ability to jump to the affected issues for more details.

Conflicts:
my_view_page.php
mod - admin/schema.php Diff File
add - core/classes/IssueAssignedTimelineEvent.class.php Diff File
add - core/classes/IssueCreatedTimelineEvent.class.php Diff File
add - core/classes/IssueMonitorTimelineEvent.class.php Diff File
add - core/classes/IssueNoteCreatedTimelineEvent.class.php Diff File
add - core/classes/IssueStatusChangeTimelineEvent.class.php Diff File
add - core/classes/IssueTagTimelineEvent.class.php Diff File
add - core/classes/TimelineEvent.class.php Diff File
add - core/timeline_api.php Diff File
add - core/timeline_inc.php Diff File
mod - css/default.css Diff File
mod - lang/strings_english.txt Diff File
mod - my_view_page.php Diff File

Issue History

Date Modified Username Field Change
2014-06-01 00:58 vboctor New Issue
2014-06-01 00:58 vboctor Status new => assigned
2014-06-01 00:58 vboctor Assigned To => vboctor
2014-06-01 00:58 vboctor File Added: timeline.png
2014-06-01 01:18 vboctor File Added: timeline2.png
2014-06-01 01:19 vboctor Note Added: 0040679
2014-06-01 02:20 vboctor Note Added: 0040681
2014-06-01 04:26 grangeway Note Added: 0040682
2014-06-01 22:24 vboctor Note Added: 0040711
2014-06-02 04:07 dregad Note Added: 0040712
2014-06-02 04:22 dregad Note Added: 0040714
2014-06-02 12:51 vboctor Note Added: 0040721
2014-06-05 01:55 vboctor Tag Attached: mantishub
2014-06-09 21:55 mantishub Changeset attached => MantisBT master 939ffe34
2014-06-09 21:55 mantishub Assigned To vboctor => mantishub
2014-06-09 21:55 mantishub Status assigned => resolved
2014-06-09 21:55 mantishub Resolution open => fixed
2014-06-09 21:55 mantishub Fixed in Version => 1.3.0-beta.1
2014-06-09 22:15 vboctor Assigned To mantishub => vboctor
2014-06-23 12:17 atrol Target Version => 1.3.0-beta.1
2014-12-08 00:34 vboctor Status resolved => closed
2014-12-14 17:43 dregad Relationship added related to 0017966
2014-12-14 17:45 dregad Relationship added related to 0017891
2014-12-14 17:45 dregad Relationship added related to 0017913
2014-12-14 17:45 dregad Relationship added related to 0017918
2014-12-14 17:45 dregad Relationship added related to 0017492
2015-01-27 19:21 atrol Category bugtracker => timeline
2015-08-26 18:03 atrol Relationship added has duplicate 0013779